;6044                                                                      9/27/95
;Handout 7


;                      CHURCH NUMERALS and Y OPERATOR


(define (inc x) (+ x 1))
(define church-zero (lambda (f) (lambda (x) x)))
(define (church-inc n) (lambda (f) (lambda (x) (f ((n f) x)))))
(define (to-num n) ((n inc) 0))

(define church-one (church-inc church-zero))
(define church-two (church-inc church-one))
(define church-three (church-inc church-two))
(define church-four (church-inc church-three))

(define church-true (lambda (x y) x) )
(define church-false (lambda (x y) y) )
(define (to-bool church-boolean) (church-boolean #t #f))

(define (church-zero? n) ((n (lambda (g) church-false)) church-true))

(define (compose f g) (lambda (x) (f (g x))))
(define church-times compose)
(define church-six (church-times church-two church-three) )

(define (church-exp m n) (n m))
(define church-nine (church-exp church-three church-two))

(define (church-ifproc test c a) (test c a))

(define (pair x y) (lambda (b) (church-ifproc b x y)))
(define (left pr) (pr church-true))
(define (right pr) (pr church-false))

(define (shift-inc pr) (pair (church-inc (left pr)) (left pr)))

(define (church-dec n) (right ((n shift-inc) (pair church-zero church-zero))))
(define (church-minus m n) ((n church-dec) m))

(define (church-add m n) <???>)

;
                        ;THE FIXED POINT OPERATOR:

(define (y f)
  ((lambda (x) (f (lambda (z) ((x x) z))))
   (lambda (x) (f (lambda (z) ((x x) z))))))


(define (factdef fact)
  (lambda (n) (if (<= n 0)
                  1
                  (* n (fact (- n 1))))))


(define factorial (y factdef))

;

;       TRANSLATING FUNCTIONAL SCHEME INTO "PURE APPLICATIVE SCHEME"

(define (purify-nat k)                   ;must be integer k >= 0
  (if (zero? k)
      '(lambda (f) (lambda (x) x))      ;church-zero
      `((lambda (n) (lambda (f) (lambda (x) (f ((n f) x)))))
        ,(purify-nat (dec k)))))

(define (purify body)
  (cond ((boolean? body)
         (if body
             '(lambda (x y) x)          ;church-true
             '(lambda (x y) y)))        ;church-false
        ((number? body)
         (if (and (integer? body) (>= body 0))
             (purify-nat body)
             "PURIFY numbers can only be naturals"))
        ((symbol? body)
         (cond ((eq? body '*)
                '(lambda (f g) (lambda (x) (f (g x))))) ;church-times
               ((eq? body '+)
                <church-plus-body>)     ;church-plus
               ((eq? body 'exp)
                '(lambda (m n) (n m)))  ;church-exp
               ((eq? body 'inc)
                '(lambda (n) (lambda (f) (lambda (x) (f ((n f) x)))))) ;church-inc
               ((eq? body 'dec) <church-dec-body>);;a little questionable
               ((eq? body 'cons)
                '(lambda (x y) (lambda (b) (b x y)))) ;pair
               ((eq? body 'car) '(lambda (pr) (pr (lambda (x y) x)))) ;left
               ((eq? body 'cdr) '(lambda (pr) (pr (lambda (x y) y)))) ;right
               (else body)))            ;leave other variables alone
        ((if? body)
         (make-combination
          (list (make-combination
                 (list (purify (if-predicate body))
                       (make-lambda '() (purify (if-consequent body)))
                       (make-lambda '() (purify (if-alternative body))))))))
        ((lambda-expression? body)
         (make-lambda (formals-of-lambda body)
                      (purify (body-of-lambda body))))
        ((combination? body)
         (make-combination (map purify (expressions-of-combination body))))
        ((body-with-defines? body)
         purify-body-with-defines)
        (else (error "PURIFY: unknown form: " body))))
               

(define (purify-body-with-defines body)
  (let ((defs (defines-of-body body)))
    (let ((vbls (map variable-of-define defs))
          (pdefexps (map purify (map expression-of-define defs)))
          (pexp (purify (expression-of-body body))))
      (make-combination
            ;;;;;HAIRY
             ))))
