;;;;EXAMPLES.SCM   Code for 6.001 Spring 95
;;;  Tests and Examples for Substitution Model 


(define church-test
  '((define (zero f) (lambda (x) x))
    (define (suc n) (lambda (f) (lambda (x) (f ((n f) x)))))
    (define (to-num n) ((n inc) 0))
    (define (x^x n) (n n))
    (define one (suc zero))
    (define two (suc one))
    (define three (suc two))
    (define four (suc three))
    (define (zero? n) ((n (lambda (x) #f)) #t))
    (to-num (x^x two))
    ))

;(smeval church-test)

(define (rec-fact-test m)
  `((define (rec-factorial n) (if (<= n 0) 1 (* n (rec-factorial (- n 1)))))
    (rec-factorial ,m)))

;(smeval (rec-fact-test 6))

(define (iter-fact-test m)
  `((define (iter-factorial n)
      (define (iter n result)
        (if (<= n 0)
            result
            (iter (- n 1) (* n result))))
      (iter n 1))
    (iter-factorial ,m)))

;(smeval (iter-fact-test 6))

(define factdef-test
  '((define (factdef fact)
      (lambda (n) (if (<= n 0)
                      1
                      (* n (fact (- n 1))))))
    (define (fact-empty n) 0)
    (define fact0 (factdef fact-empty))
    (define fact1 (factdef fact0))
    (define fact2 (factdef fact1))
    (fact2 2)))

;(smeval factdef-test)

(define (y-fact-test m)
  `((define
      (y f)
      ((lambda (x) (f (lambda (z) ((x x) z))))
       (lambda (x) (f (lambda (z) ((x x) z))))))
    (define (factdef fact)
      (lambda (n) (if (<= n 0)
                      1
                      (* n (fact (- n 1))))))
    (define y-fact (y factdef))
    (y-fact ,m)))

;(smeval (y-fact-test 6))

(define (y-iter-fact-test m)
  `((define (Y2 f)
      ((lambda (x) (f (lambda(z1 z2) ((x x) z1 z2))))
       (lambda (x) (f (lambda(z1 z2) ((x x) z1 z2))))))
    (define (y-iter-fact n)
      ((Y2 (lambda (iter)
             (lambda (n result)
               (if (<= n 0)
                   result
                   (iter (- n 1) (* n result))))))
       n 1))
    (y-iter-fact ,m)))

;(smeval (y-iter-fact-test 6))

(define (set-member-test m)
  `((define (empty-set n) #f)
    (define put (lambda (element set)
                  (lambda (possible-element)
                    (if (equal? possible-element element)
                        #t
                        (set possible-element)))))
    ((put 2 (put 4 (put 6 empty-set))) ,m)))

;(smeval (set-member-test 2))
;(smeval (set-member-test 6))
;(smeval (set-member-test 1))

(define tree-test
  '((define (pair l r) (lambda (p) (p l r)))
    (define left (lambda (p) (p (lambda (x y) x))))
    (define right (lambda (p) (p (lambda (x y) y))))
    (define tree->tree (lambda (tree)
                         (define t->t
                           (lambda (tree continue)
                             (if (number? tree)
                                 (continue (inc tree))
                                 (t->t
                                  (left tree)
                                  (lambda (a)
                                    (t->t
                                     (right tree)
                                     (lambda (d) (continue (pair a d)))))))))
                         (t->t tree (lambda (x) x))))
    (define (tree->list tree)
      (if (number? tree)
          tree
          (list (tree->list (left tree))
                (tree->list (right tree)))))
    (tree->list (tree->tree (pair (pair (pair 2 5) 9) (pair 3 44))))))

;(smeval tree-test)


(define (ln n)
  (if (zero? n)
      '()
      (cons n (ln (- n 1)))))


(define (ltree-test l)
  `((define pair cons)
    (define left car)
    (define right cdr)
    (define tree->tree
      (lambda (tree)
        (define t->t
          (lambda (tree continue)
            (if (number? tree)
                (continue (inc tree))
                (if (null? tree)
                    (continue ())
                    (t->t
                     (left tree)
                     (lambda (a)
                       (t->t
                        (right tree)
                        (lambda (d) (continue (pair a d))))))))))
        (t->t tree (lambda (x) x))))
    (tree->tree ,l)))

;(smeval (ltree-test (import-from-scheme '(2 (3 (4 5) (((6))))))))

(define (thunk-test k)
  `((define (make-loopthunk n)
                    ;;returns thunk s.t. (( ...  (thunk) ...)) is (thunk . 'anything)
                    ;;                   |<--n-->|
      (define (aux m)
        (if (zero? m)
            (cons (lambda () (aux n)) 'anything)
            (lambda () (aux (- m 1)))))
      (aux n))
    (define (test loopthunk)
      (define (repeat thunk result)
        (if (pair? thunk)
            result
            (repeat (thunk)
                    (cons
                     (inc (car result))
                     result))))
      (repeat loopthunk (list 0)))
    (test (make-loopthunk ,k))))

;(smeval (thunk-test 6))

(define map-test
  '((define (vals-at x)
     (map
      (lambda (f) (f x))
      (list (lambda (n) n) inc sin cos)))
   (vals-at 0)))

;(smeval map-test)

(define apply-map-test
  '(apply
    (lambda (x1 x2 x3 x4 x5)
      (list
       (cons 'x1 x1)
       (cons 'x2 x2)
       (cons 'x3 x3)
       (cons 'x4 x4)
       (cons 'x5 x5)))
     (map
      (lambda (l) (cdr (cdr l)))
      (list
       (list 'a 0 1 2)
       (list 'b 3 4)
       (list 'will 'disappear)
       (list 'end 'end 'end)
       (list 'gone 'entirely)))))

;(smeval apply-map-test)

(define pptest
  '(list
     sin
     (lambda(z) (lambda (y) (y (inc z) w)))
     (lambda (z) z)
     (lambda(z)
       (cons ((lambda (a b) (define c 1) (lambda () (cons c a b)))
              z
              'symb)
             (cons
              'b
              (lambda(z w)
                (define (f x) ((f z) (z x))) (f (z w))))))))

;(pp (smeval pptest))

;(smeval '(list? (list ())))

(define garbage-test
  '((define b 33)
    (define a (inc b))
    (define c (* a 2))
    (cons a a)))

;(smeval garbage-test)

(define unassigned-test
  '((define c (* a 2))
    (define a (inc b))
    (define b 33)
    (cons a a)))

;(smeval unassigned-test)

;(smeval '((define delta (lambda (x) (x x))) (delta delta)))

;(evalthru '((define delta (lambda (x) (x x))) (delta delta)))


(define aptest
  '(append (list) (list) (list 1 2) (list 3) () (list (list 'a) 'b)))

;(smeval aptest)

(define short-tests
  (list church-test
        (rec-fact-test 6)
        (iter-fact-test 6)
        (y-fact-test 6)
        factdef-test
        (y-iter-fact-test 6)
        (set-member-test 2)
        (set-member-test 6)
        (set-member-test 1)
        (thunk-test 6)
        map-test
        apply-map-test
        pptest
        '(list? (list ()))
        garbage-test
        unassigned-test
        aptest))

;(map smeval short-tests)

(define tree-tests
  (list
   (ltree-test (import-from-scheme '(2 (3 (4 5) (((6)))))))
   tree-test))

;(map smeval tree-tests)


(define fibtest
  '((define (fib n)
      (if (< n 2)
          n
          (+ (fib (- n 1)) (fib (- n 2)))))
    (fib 7)))


;(smeval fibtest)

(define maxtest
 '((define (max2d f n)
     (if (zero? n)
         0
         (max (max1d (lambda (i) (f n i)) (- n 1))
              (max1d (lambda (j) (f j n)) n)
              (max2d f (- n 1)))))
   (define (max1d h n)
     (define (iter max-so-far k)
       (if (zero? k)
           max-so-far
           (iter
            (max max-so-far (h k))
            (- k 1))))
     (iter 0 n))
   (define (m n)
     (lambda (i j)
       (let ((2n (* 2 n)))
         (- 2n (+ i j)))))
   (max2d (m 4) 4)))

;(smeval maxtest)

;changes at every step
;(smeval '(cons (cond (#t ((lambda (y) 2)3))) 4))


(define q1-test
  '((define (min-and-max list-of-numbers)
  (define (scan rest continue)
    ;; continue = (lambda (min max) ...)
    (if (null? (cdr rest))
	(continue (car rest) (car rest))
	(scan (cdr rest)
	      (lambda (min-cdr-rest max-cdr-rest)
		(cond ((< (car rest) min-cdr-rest)
		       (continue (car rest) max-cdr-rest))
		      ((> (car rest) max-cdr-rest)
		       (continue min-cdr-rest (car rest)))
		      (else
		       (continue min-cdr-rest max-cdr-rest)))))))
  (scan list-of-numbers cons))
    (min-and-max '(3 5 2 8 1 9 9 7))))

;(smeval q1-test)

;(smeval '(and 2 3 (lambda () (+ 4 5))))

;(smeval '((define x 0) (and ((lambda () (begin (set! x (+ 4 5)) x))) #f)))


;;;                   SET!

(define begintest
  '((define (makethunk n x)
      (let ((x (cons (* n x) ())))
        (lambda ()
          (begin (set! x (cons (+ n (car x)) x))
                 x))))
    (define th82 (makethunk 8 2))
    (cons (th82)(th82))))

;(smeval begintest)

(define thunktest
  '((define (makethunk n x)
      (let ((x (cons (* n x) ())))
        (lambda ()
          (cons (set! x (cons (+ n (car x)) x))
                x))))
    (define th83 (makethunk 8 3))
    (cons (th83)(th83))))


;(smeval thunktest)

(define tht
  '((define (makethunk2 n)
      (let ((x (lambda () n)))
        (lambda ()
          (cons(set! x
                (let ((x x)) (lambda () (1+ (x)))))
          (x)))))
    (define th2 (makethunk2 7))
    (cons (th2) (th2))))

;(smeval tht)

(define tht3
  '((define (makethunk3 n)
  (let ((x (lambda () n)))
    (lambda ()
      (cons (set! x
	    (let ((y x)) (lambda () (1+ (y)))))
      (x)))))
    (define th3 (makethunk3 9))
    (cons (th3) (th3))))

;(smeval tht3)

(define learner-pred-test
  '((define (make-state-machine state next-state-proc output-proc)
      (lambda (input)
        (let ((temp (set! state (next-state-proc input state)))
              (output (output-proc input state)))
              output)))
    (define learner2
      (let ((remember
             (lambda (input input-history-pred)
               (lambda (future-input)
                 (if (equal? future-input input) #t
                     (input-history-pred future-input))))))
        (make-state-machine
         (lambda(input) #f)
         remember
         (lambda (input input-history-pred)	
           (input-history-pred input)))))
    (map learner2 (list 4 3 2 1 3 1 2 1))))

;(smeval learner-pred-test)

(define learner-list-test
  '((define (make-state-machine state next-state-proc output-proc)
      (lambda (input)
        (let ((temp (set! state (next-state-proc input state)))
              (output (output-proc input state)))
              output)))
    (define learner				
      (make-state-machine                   
       ()
       cons
       (lambda (input input-history-list)
         (if (member input input-history-list)
             #t
             #f))))
    (map learner (list 4 3 2 1 3 1 2 1))))

;(smeval learner-list-test)


(define learner-test
  '((define (make-state-machine state next-state-proc output-proc)
      (lambda (input)
        (let ((output (output-proc input state)))
          ((lambda (a b) b)
           (set! state (next-state-proc input state))
           output))))
    (define total
      (make-state-machine
       10000 
       +
       +))
    (define total2                 
      (make-state-machine
       10000
       +
       +))
    (define learner				
      (make-state-machine                   
       ()
       cons
       (lambda (input input-history-list)
         (if (member input input-history-list)
             #t
             #f))))
    (define politician
      (make-state-machine
       ()
       cons
       (lambda (voter acquaintance-list)
         (if (member voter acquaintance-list)
             (list 'nice 'ta 'see 'ya 'again voter)
             (list 'pleased 'ta 'meet 'ya voter)))))
    (define learner2
      (let ((remember
             (lambda (input input-history-pred)
               (lambda (future-input)
                 (if (equal? future-input input) #t
                     (input-history-pred future-input))))))
        (make-state-machine
         (lambda(input) #f)
         remember
         (lambda (input input-history-pred)	
           (input-history-pred input)))))
    (define Bens-fixed-learner
      (let ((input-history-pred (lambda(input) #f))
            (output-proc (lambda (input input-history-pred)
                           (input-history-pred input))))
        (lambda (input)
          (let ((output (output-proc input input-history-pred))
                (input-history-copy input-history-pred))
            ((lambda (a b) b)(set! input-history-pred
                  (lambda (future-input)
                    (if (equal? future-input input) #t
                        (input-history-copy future-input))))
            output)))))
    (list (bens-fixed-learner 'tom)
          (bens-fixed-learner 'tom)
          (bens-fixed-learner 'harry)
          (politician 'bill)
          (politician 'bill)
          (politician 'joe)
          (total 1)
          (total 1))))

;(smeval learner-test)

(define set!-defs-test
 '((define x 3)
   ((lambda ()
      (define y 2)
      (begin (set! x 1)
              (list "x: " x "y: " y))))))

;(smeval set!-defs-test)


(define set!-defs-test1
 '((define x1 3)
   ((lambda ()
      (define y 2)
      (begin (set! x 1)
             (list "x: " x "y: " y))))))

;(smeval set!-defs-test1)

(define all-set!-test
  (list
   begintest
   thunktest
   learner-test
   learner-list-test
   learner-pred-test
   tht3
   tht
   set!-defs-test
   set!-defs-test1))

;(map smeval all-set!-test)

